//**************************************************************************
//**                                                                      **
//**            Copyright 1998 by Andrew D. Pitonyak                      **
//**                                                                      **
//**   This code belongs to me, and I make no claims of functionality.    **
//**   If you desire to use it, please discuss it with me, because I am   **
//**   curious how this code is used.                                     **
//**                                                                      **
//**   Oh yes, and any bugs that you fix, please let me know...           **
//**                                                                      **
//**                                Primatech, Inc.                       **
//**   Andrew D. Pitonyak           Andrew D. Pitonyak                    **
//**   4446 Mobile Drive #105       445 Hutchinson, Suite #200            **
//**   Columbus, OH 43220           Columbus, OH 43235                    **
//**   (614)-442-8615               (614)-841-9800                        **
//**                                andyp@primatech.com                   **
//**                                                                      **
//**************************************************************************

#define INCL_DOSPROCESS       // DosPhysicalDisk()
#define INCL_DOSERRORS        // NO_ERROR, ERROR_INVALID_FUNCTION, ...
#define INCL_DOSDEVICES       // INFO_COUNT_PARTITIONABLE_DISKS

#include <os2.h>
#include <stdlib.h>
#include <string.h>
#include <exe.h>              // WORD
#include <iostream.h>
#include <iomanip.h>
#include <assert.h>


typedef struct {
   APIRET error_;
   CHAR*  errorStr_;
} API_CHR_ERROR;

void printErrorMessage(APIRET error, char *msg)
{
   API_CHR_ERROR err[] = {
//{NO_ERROR, "NO_ERROR"},
{ERROR_INVALID_FUNCTION, "INVALID_FUNCTION"},
{ERROR_FILE_NOT_FOUND, "FILE_NOT_FOUND"},
{ERROR_PATH_NOT_FOUND, "PATH_NOT_FOUND"},
{ERROR_TOO_MANY_OPEN_FILES, "TOO_MANY_OPEN_FILES"},
{ERROR_ACCESS_DENIED, "ACCESS_DENIED"},
{ERROR_INVALID_HANDLE, "INVALID_HANDLE"},
{ERROR_ARENA_TRASHED, "ARENA_TRASHED, Memory blocks bad"},
{ERROR_NOT_ENOUGH_MEMORY, "NOT_ENOUGH_MEMORY"},
{ERROR_INVALID_BLOCK, "INVALID_BLOCK or memory address"},
{ERROR_BAD_ENVIRONMENT, "BAD_ENVIRONMENT"},
{ERROR_BAD_FORMAT, "BAD_FORMAT"},
{ERROR_INVALID_ACCESS, "INVALID_ACCESS"},
{ERROR_INVALID_DATA, "INVALID_DATA"},
{ERROR_INVALID_DRIVE, "INVALID_DRIVE"},
{ERROR_CURRENT_DIRECTORY, "CURRENT_DIRECTORY"},
{ERROR_NOT_SAME_DEVICE, "NOT_SAME_DEVICE"},
{ERROR_NO_MORE_FILES, "NO_MORE_FILES"},
{ERROR_WRITE_PROTECT, "WRITE_PROTECT"},
{ERROR_BAD_UNIT, "BAD_UNIT"},
{ERROR_NOT_READY, "NOT_READY"},
{ERROR_BAD_COMMAND, "BAD_COMMAND"},
{ERROR_CRC, "CRC"},
{ERROR_BAD_LENGTH, "BAD_LENGTH or req structure"},
{ERROR_SEEK, "SEEK"},
{ERROR_NOT_DOS_DISK, "NOT_DOS_DISK, unknown media"},
{ERROR_SECTOR_NOT_FOUND, "SECTOR_NOT_FOUND"},
{ERROR_OUT_OF_PAPER, "OUT_OF_PAPER"},
{ERROR_WRITE_FAULT, "WRITE_FAULT"},
{ERROR_READ_FAULT, "READ_FAULT"},
{ERROR_GEN_FAILURE, "GEN_FAILURE"},
{ERROR_SHARING_VIOLATION, "SHARING_VIOLATION"},
{ERROR_LOCK_VIOLATION, "LOCK_VIOLATION"},
{ERROR_WRONG_DISK, "WRONG_DISK, or invalid disk change"},
{ERROR_FCB_UNAVAILABLE, "FCB_UNAVAILABLE"},
{ERROR_SHARING_BUFFER_EXCEEDED, "SHARING_BUFFER_EXCEEDED"},
{ERROR_CODE_PAGE_MISMATCHED, "CODE_PAGE_MISMATCHED or write protect"},
{ERROR_HANDLE_EOF, "HANDLE_EOF or bad unit"},
{ERROR_HANDLE_DISK_FULL, "HANDLE_DISK_FULL or not ready"},
{ 40, "BAD_COMMAND"},
{ 41, "CRC"},
{ 42, "BAD_LENGTH"},
{ 43, "SEEK"},
{ 44, "NOT_DOS_DISK"},
{ 45, "SECTOR_NOT_FOUND"},
{ 46, "OUT_OF_PAPER"},
{ 47, "WRITE_FAULT"},
{ 48, "READ_FAULT"},
{ 49, "GEN_FAILURE"},
{ERROR_NOT_SUPPORTED, "NOT_SUPPORTED"},
{ERROR_REM_NOT_LIST, "REM_NOT_LIST"},
{ERROR_DUP_NAME, "DUP_NAME"},
{ERROR_BAD_NETPATH, "BAD_NETPATH"},
{ERROR_NETWORK_BUSY, "NETWORK_BUSY"},
{ERROR_DEV_NOT_EXIST, "DEV_NOT_EXIST"},
{ERROR_TOO_MANY_CMDS, "TOO_MANY_CMDS"},
{ERROR_ADAP_HDW_ERR, "ADAP_HDW_ERR"},
{ERROR_BAD_NET_RESP, "BAD_NET_RESP"},
{ERROR_UNEXP_NET_ERR, "UNEXP_NET_ERR"},
{ERROR_BAD_REM_ADAP, "BAD_REM_ADAP"},
{ERROR_PRINTQ_FULL, "PRINTQ_FULL"},
{ERROR_NO_SPOOL_SPACE, "NO_SPOOL_SPACE"},
{ERROR_PRINT_CANCELLED, "PRINT_CANCELLED"},
{ERROR_NETNAME_DELETED, "NETNAME_DELETED"},
{ERROR_NETWORK_ACCESS_DENIED, "NETWORK_ACCESS_DENIED"},
{ERROR_BAD_DEV_TYPE, "BAD_DEV_TYPE"},
{ERROR_BAD_NET_NAME, "BAD_NET_NAME"},
{ERROR_TOO_MANY_NAMES, "TOO_MANY_NAMES"},
{ERROR_TOO_MANY_SESS, "TOO_MANY_SESS"},
{ERROR_SHARING_PAUSED, "SHARING_PAUSED"},
{ERROR_REQ_NOT_ACCEP, "REQ_NOT_ACCEP"},
{ERROR_REDIR_PAUSED, "REDIR_PAUSED"},
{ERROR_SBCS_ATT_WRITE_PROT, "SBCS_ATT_WRITE_PROT"},
{ERROR_SBCS_GENERAL_FAILURE, "SBCS_GENERAL_FAILURE"},
{ERROR_XGA_OUT_MEMORY, "XGA_OUT_MEMORY"},
{ERROR_FILE_EXISTS, "FILE_EXISTS"},
{ERROR_DUP_FCB, "DUP_FCB"},
{ERROR_CANNOT_MAKE, "CANNOT_MAKE"},
{ERROR_FAIL_I24, "FAIL_I24"},
{ERROR_OUT_OF_STRUCTURES, "OUT_OF_STRUCTURES"},
{ERROR_ALREADY_ASSIGNED, "ALREADY_ASSIGNED"},
{ERROR_INVALID_PASSWORD, "INVALID_PASSWORD"},
{ERROR_INVALID_PARAMETER, "INVALID_PARAMETER"},
{ERROR_NET_WRITE_FAULT, "NET_WRITE_FAULT"},
{ERROR_NO_PROC_SLOTS, "NO_PROC_SLOTS"},
{ERROR_NOT_FROZEN, "NOT_FROZEN or comp not loaded"},
{ERR_TSTOVFL, "ERR_TSTOVFL"},
{ERR_TSTDUP, "ERR_TSTDUP"},
{ERROR_NO_ITEMS, "NO_ITEMS"},
{ERROR_INTERRUPT, "INTERRUPT"},
{ERROR_DEVICE_IN_USE, "DEVICE_IN_USE"},
{ERROR_TOO_MANY_SEMAPHORES, "TOO_MANY_SEMAPHORES"},
{ERROR_EXCL_SEM_ALREADY_OWNED, "EXCL_SEM_ALREADY_OWNED"},
{ERROR_SEM_IS_SET, "SEM_IS_SET"},
{ERROR_TOO_MANY_SEM_REQUESTS, "TOO_MANY_SEM_REQUESTS"},
{ERROR_INVALID_AT_INTERRUPT_TIME, "INVALID_AT_INTERRUPT_TIME"},
{ERROR_SEM_OWNER_DIED, "SEM_OWNER_DIED"},
{ERROR_SEM_USER_LIMIT, "SEM_USER_LIMIT or disk change"},
{ERROR_DISK_CHANGE, "DISK_CHANGE"},
{ERROR_DRIVE_LOCKED, "DRIVE_LOCKED"},
{ERROR_BROKEN_PIPE, "BROKEN_PIPE"},
{ERROR_OPEN_FAILED, "OPEN_FAILED"},
{ERROR_BUFFER_OVERFLOW, "BUFFER_OVERFLOW or filename long"},
{ERROR_DISK_FULL, "DISK_FULL"},
{ERROR_NO_MORE_SEARCH_HANDLES, "NO_MORE_SEARCH_HANDLES"},
{ERROR_INVALID_TARGET_HANDLE, "INVALID_TARGET_HANDLE"},
{ERROR_PROTECTION_VIOLATION, "PROTECTION_VIOLATION"},
{ERROR_VIOKBD_REQUEST, "VIOKBD_REQUEST"},
{ERROR_INVALID_CATEGORY, "INVALID_CATEGORY"},
{ERROR_INVALID_VERIFY_SWITCH, "INVALID_VERIFY_SWITCH"},
{ERROR_BAD_DRIVER_LEVEL, "BAD_DRIVER_LEVEL"},
{ERROR_CALL_NOT_IMPLEMENTED, "CALL_NOT_IMPLEMENTED"},
{ERROR_SEM_TIMEOUT, "SEM_TIMEOUT"},
{ERROR_INSUFFICIENT_BUFFER, "INSUFFICIENT_BUFFER"},
{ERROR_INVALID_NAME, "INVALID_NAME"},
{123, "HPFS INVALID VOLUME CHAR"},
{ERROR_INVALID_LEVEL, "INVALID_LEVEL"},
{ERROR_NO_VOLUME_LABEL, "NO_VOLUME_LABEL"},
{ERROR_MOD_NOT_FOUND, "MOD_NOT_FOUND"},
{ERROR_PROC_NOT_FOUND, "PROC_NOT_FOUND"},
{ERROR_WAIT_NO_CHILDREN, "WAIT_NO_CHILDREN"},
{ERROR_CHILD_NOT_COMPLETE, "CHILD_NOT_COMPLETE"},
{ERROR_DIRECT_ACCESS_HANDLE, "DIRECT_ACCESS_HANDLE"},
{ERROR_NEGATIVE_SEEK, "NEGATIVE_SEEK"},
{ERROR_SEEK_ON_DEVICE, "SEEK_ON_DEVICE"},
{ERROR_IS_JOIN_TARGET, "IS_JOIN_TARGET"},
{ERROR_IS_JOINED, "IS_JOINED"},
{ERROR_IS_SUBSTED, "IS_SUBSTED"},
{ERROR_NOT_JOINED, "NOT_JOINED"},
{ERROR_NOT_SUBSTED, "NOT_SUBSTED"},
{ERROR_JOIN_TO_JOIN, "JOIN_TO_JOIN"},
{ERROR_SUBST_TO_SUBST, "SUBST_TO_SUBST"},
{ERROR_JOIN_TO_SUBST, "JOIN_TO_SUBST"},
{ERROR_SUBST_TO_JOIN, "SUBST_TO_JOIN"},
{ERROR_BUSY_DRIVE, "BUSY_DRIVE"},
{ERROR_SAME_DRIVE, "SAME_DRIVE"},
{ERROR_DIR_NOT_ROOT, "DIR_NOT_ROOT"},
{ERROR_DIR_NOT_EMPTY, "DIR_NOT_EMPTY"},
{ERROR_IS_SUBST_PATH, "IS_SUBST_PATH"},
{ERROR_IS_JOIN_PATH, "IS_JOIN_PATH"},
{ERROR_PATH_BUSY, "PATH_BUSY"},
{ERROR_IS_SUBST_TARGET, "IS_SUBST_TARGET"},
{ERROR_SYSTEM_TRACE, "SYSTEM_TRACE"},
{ERROR_INVALID_EVENT_COUNT, "INVALID_EVENT_COUNT"},
{ERROR_TOO_MANY_MUXWAITERS, "TOO_MANY_MUXWAITERS"},
{ERROR_INVALID_LIST_FORMAT, "INVALID_LIST_FORMAT"},
{ERROR_LABEL_TOO_LONG, "LABEL_TOO_LONG"},
{ERROR_TOO_MANY_TCBS, "TOO_MANY_TCBS"},
{ERROR_SIGNAL_REFUSED, "SIGNAL_REFUSED"},
{ERROR_DISCARDED, "DISCARDED"},
{ERROR_NOT_LOCKED, "NOT_LOCKED"},
{ERROR_BAD_THREADID_ADDR, "BAD_THREADID_ADDR"},
{ERROR_BAD_ARGUMENTS, "BAD_ARGUMENTS"},
{ERROR_BAD_PATHNAME, "BAD_PATHNAME"},
{ERROR_SIGNAL_PENDING, "SIGNAL_PENDING"},
{ERROR_UNCERTAIN_MEDIA, "UNCERTAIN_MEDIA"},
{ERROR_MAX_THRDS_REACHED, "MAX_THRDS_REACHED"},
{ERROR_MONITORS_NOT_SUPPORTED, "MONITORS_NOT_SUPPORTED"},
{ERROR_UNC_DRIVER_NOT_INSTALLED, "UNC_DRIVER_NOT_INSTALLED"},
{ERROR_LOCK_FAILED, "LOCK_FAILED"},
{ERROR_SWAPIO_FAILED, "SWAPIO_FAILED"},
{ERROR_SWAPIN_FAILED, "SWAPIN_FAILED"},
{ERROR_BUSY, "BUSY"},
{171, "INT TOO LONG"},
{ERROR_CANCEL_VIOLATION, "CANCEL_VIOLATION"},
{ERROR_ATOMIC_LOCK_NOT_SUPPORTED, "ATOMIC_LOCK_NOT_SUPPORTED"},
{ERROR_READ_LOCKS_NOT_SUPPORTED, "READ_LOCKS_NOT_SUPPORTED"},
{ERROR_INVALID_SEGMENT_NUMBER, "INVALID_SEGMENT_NUMBER"},
{ERROR_INVALID_CALLGATE, "INVALID_CALLGATE"},
{ERROR_INVALID_ORDINAL, "INVALID_ORDINAL"},
{ERROR_ALREADY_EXISTS, "ALREADY_EXISTS"},
{ERROR_NO_CHILD_PROCESS, "NO_CHILD_PROCESS"},
{ERROR_CHILD_ALIVE_NOWAIT, "CHILD_ALIVE_NOWAIT"},
{ERROR_INVALID_FLAG_NUMBER, "INVALID_FLAG_NUMBER"},
{ERROR_SEM_NOT_FOUND, "SEM_NOT_FOUND"},
{ERROR_INVALID_STARTING_CODESEG, "INVALID_STARTING_CODESEG"},
{ERROR_INVALID_STACKSEG, "INVALID_STACKSEG"},
{ERROR_INVALID_MODULETYPE, "INVALID_MODULETYPE"},
{ERROR_INVALID_EXE_SIGNATURE, "INVALID_EXE_SIGNATURE"},
{ERROR_EXE_MARKED_INVALID, "EXE_MARKED_INVALID"},
{ERROR_BAD_EXE_FORMAT, "BAD_EXE_FORMAT"},
{ERROR_ITERATED_DATA_EXCEEDS_64k, "ITERATED_DATA_EXCEEDS_64k"},
{ERROR_INVALID_MINALLOCSIZE, "INVALID_MINALLOCSIZE"},
{ERROR_DYNLINK_FROM_INVALID_RING, "DYNLINK_FROM_INVALID_RING"},
{ERROR_IOPL_NOT_ENABLED, "IOPL_NOT_ENABLED"},
{ERROR_INVALID_SEGDPL, "INVALID_SEGDPL"},
{ERROR_AUTODATASEG_EXCEEDS_64k, "AUTODATASEG_EXCEEDS_64k"},
{ERROR_RING2SEG_MUST_BE_MOVABLE, "RING2SEG_MUST_BE_MOVABLE"},
{ERROR_RELOC_CHAIN_XEEDS_SEGLIM, "RELOC_CHAIN_XEEDS_SEGLIM"},
{ERROR_INFLOOP_IN_RELOC_CHAIN, "INFLOOP_IN_RELOC_CHAIN"},
{ERROR_ENVVAR_NOT_FOUND, "ENVVAR_NOT_FOUND"},
{ERROR_NOT_CURRENT_CTRY, "NOT_CURRENT_CTRY"},
{ERROR_NO_SIGNAL_SENT, "NO_SIGNAL_SENT"},
{ERROR_FILENAME_EXCED_RANGE, "FILENAME_EXCED_RANGE"},
{ERROR_RING2_STACK_IN_USE, "RING2_STACK_IN_USE"},
{ERROR_META_EXPANSION_TOO_LONG, "META_EXPANSION_TOO_LONG"},
{ERROR_INVALID_SIGNAL_NUMBER, "INVALID_SIGNAL_NUMBER"},
{ERROR_THREAD_1_INACTIVE, "THREAD_1_INACTIVE"},
{ERROR_INFO_NOT_AVAIL, "INFO_NOT_AVAIL"},
{ERROR_LOCKED, "LOCKED"},
{ERROR_BAD_DYNALINK, "BAD_DYNALINK"},
{ERROR_TOO_MANY_MODULES, "TOO_MANY_MODULES"},
{ERROR_NESTING_NOT_ALLOWED, "NESTING_NOT_ALLOWED"},
{ERROR_CANNOT_SHRINK, "CANNOT_SHRINK"},
{ERROR_ZOMBIE_PROCESS, "ZOMBIE_PROCESS"},
{ERROR_STACK_IN_HIGH_MEMORY, "STACK_IN_HIGH_MEMORY"},
{ERROR_INVALID_EXITROUTINE_RING, "INVALID_EXITROUTINE_RING"},
{ERROR_GETBUF_FAILED, "GETBUF_FAILED"},
{ERROR_FLUSHBUF_FAILED, "FLUSHBUF_FAILED"},
{ERROR_TRANSFER_TOO_LONG, "TRANSFER_TOO_LONG"},
{ERROR_FORCENOSWAP_FAILED, "FORCENOSWAP_FAILED"},
{ERROR_SMG_NO_TARGET_WINDOW, "SMG_NO_TARGET_WINDOW"},
{ERROR_NO_CHILDREN, "NO_CHILDREN"},
{ERROR_INVALID_SCREEN_GROUP, "INVALID_SCREEN_GROUP"},
{ERROR_BAD_PIPE, "BAD_PIPE"},
{ERROR_PIPE_BUSY, "PIPE_BUSY"},
{ERROR_NO_DATA, "NO_DATA"},
{ERROR_PIPE_NOT_CONNECTED, "PIPE_NOT_CONNECTED"},
{ERROR_MORE_DATA, "MORE_DATA"},
{ERROR_VC_DISCONNECTED, "VC_DISCONNECTED"},
{ERROR_CIRCULARITY_REQUESTED, "CIRCULARITY_REQUESTED"},
{ERROR_DIRECTORY_IN_CDS, "DIRECTORY_IN_CDS"},
{ERROR_INVALID_FSD_NAME, "INVALID_FSD_NAME"},
{ERROR_INVALID_PATH, "INVALID_PATH"},
{ERROR_INVALID_EA_NAME, "INVALID_EA_NAME"},
{ERROR_EA_LIST_INCONSISTENT, "EA_LIST_INCONSISTENT"},
{ERROR_EA_LIST_TOO_LONG, "EA_LIST_TOO_LONG"},
{ERROR_NO_META_MATCH, "NO_META_MATCH"},
{ERROR_FINDNOTIFY_TIMEOUT, "FINDNOTIFY_TIMEOUT"},
{ERROR_NO_MORE_ITEMS, "NO_MORE_ITEMS"},
{ERROR_SEARCH_STRUC_REUSED, "SEARCH_STRUC_REUSED"},
{ERROR_CHAR_NOT_FOUND, "CHAR_NOT_FOUND"},
{ERROR_TOO_MUCH_STACK, "TOO_MUCH_STACK"},
{ERROR_INVALID_ATTR, "INVALID_ATTR"},
{ERROR_INVALID_STARTING_RING, "INVALID_STARTING_RING"},
{ERROR_INVALID_DLL_INIT_RING, "INVALID_DLL_INIT_RING"},
{ERROR_CANNOT_COPY, "CANNOT_COPY"},
{ERROR_DIRECTORY, "DIRECTORY"},
{ERROR_OPLOCKED_FILE, "OPLOCKED_FILE"},
{ERROR_OPLOCK_THREAD_EXISTS, "OPLOCK_THREAD_EXISTS"},
{ERROR_VOLUME_CHANGED, "VOLUME_CHANGED"},
{ERROR_FINDNOTIFY_HANDLE_IN_USE, "FINDNOTIFY_HANDLE_IN_USE"},
{ERROR_FINDNOTIFY_HANDLE_CLOSED, "FINDNOTIFY_HANDLE_CLOSED"},
{ERROR_NOTIFY_OBJECT_REMOVED, "NOTIFY_OBJECT_REMOVED"},
{ERROR_ALREADY_SHUTDOWN, "ALREADY_SHUTDOWN"},
{ERROR_EAS_DIDNT_FIT, "EAS_DIDNT_FIT"},
{ERROR_EA_FILE_CORRUPT, "EA_FILE_CORRUPT"},
{ERROR_EA_TABLE_FULL, "EA_TABLE_FULL"},
{ERROR_INVALID_EA_HANDLE, "INVALID_EA_HANDLE"},
{ERROR_NO_CLUSTER, "NO_CLUSTER"},
{ERROR_CREATE_EA_FILE, "CREATE_EA_FILE"},
{ERROR_CANNOT_OPEN_EA_FILE, "CANNOT_OPEN_EA_FILE"},
{ERROR_EAS_NOT_SUPPORTED, "EAS_NOT_SUPPORTED"},
{ERROR_NEED_EAS_FOUND, "NEED_EAS_FOUND"},
{ERROR_DUPLICATE_HANDLE, "DUPLICATE_HANDLE"},
{ERROR_DUPLICATE_NAME, "DUPLICATE_NAME"},
{ERROR_EMPTY_MUXWAIT, "EMPTY_MUXWAIT"},
{ERROR_MUTEX_OWNED, "MUTEX_OWNED"},
{ERROR_NOT_OWNER, "NOT_OWNER"},
{ERROR_PARAM_TOO_SMALL, "PARAM_TOO_SMALL"},
{ERROR_TOO_MANY_HANDLES, "TOO_MANY_HANDLES"},
{ERROR_TOO_MANY_OPENS, "TOO_MANY_OPENS"},
{ERROR_WRONG_TYPE, "WRONG_TYPE"},
{ERROR_UNUSED_CODE, "UNUSED_CODE"},
{ERROR_THREAD_NOT_TERMINATED, "THREAD_NOT_TERMINATED"},
{ERROR_INIT_ROUTINE_FAILED, "INIT_ROUTINE_FAILED"},
{ERROR_MODULE_IN_USE, "MODULE_IN_USE"},
{ERROR_NOT_ENOUGH_WATCHPOINTS, "NOT_ENOUGH_WATCHPOINTS"},
{ERROR_TOO_MANY_POSTS, "TOO_MANY_POSTS"},
{ERROR_ALREADY_POSTED, "ALREADY_POSTED"},
{ERROR_ALREADY_RESET, "ALREADY_RESET"},
{ERROR_SEM_BUSY, "SEM_BUSY"},
{ERROR_INVALID_PROCID, "INVALID_PROCID"},
{ERROR_INVALID_PDELTA, "INVALID_PDELTA"},
{ERROR_NOT_DESCENDANT, "NOT_DESCENDANT"},
{ERROR_NOT_SESSION_MANAGER, "NOT_SESSION_MANAGER"},
{ERROR_INVALID_PCLASS, "INVALID_PCLASS"},
{ERROR_INVALID_SCOPE, "INVALID_SCOPE"},
{ERROR_INVALID_THREADID, "INVALID_THREADID"},
{ERROR_DOSSUB_SHRINK, "DOSSUB_SHRINK"},
{ERROR_DOSSUB_NOMEM, "DOSSUB_NOMEM"},
{ERROR_DOSSUB_OVERLAP, "DOSSUB_OVERLAP"},
{ERROR_DOSSUB_BADSIZE, "DOSSUB_BADSIZE"},
{ERROR_DOSSUB_BADFLAG, "DOSSUB_BADFLAG"},
{ERROR_DOSSUB_BADSELECTOR, "DOSSUB_BADSELECTOR"},
{ERROR_MR_MSG_TOO_LONG, "MR_MSG_TOO_LONG"},
{MGS_MR_MSG_TOO_LONG, "MGS_MR_MSG_TOO_LONG"},
{ERROR_MR_MID_NOT_FOUND, "MR_MID_NOT_FOUND"},
{ERROR_MR_UN_ACC_MSGF, "MR_UN_ACC_MSGF"},
{ERROR_MR_INV_MSGF_FORMAT, "MR_INV_MSGF_FORMAT"},
{ERROR_MR_INV_IVCOUNT, "MR_INV_IVCOUNT"},
{ERROR_MR_UN_PERFORM, "MR_UN_PERFORM"},
{ERROR_TS_WAKEUP, "TS_WAKEUP"},
{ERROR_TS_SEMHANDLE, "TS_SEMHANDLE"},
{ERROR_TS_NOTIMER, "TS_NOTIMER"},
{ERROR_TS_HANDLE, "TS_HANDLE"},
{ERROR_TS_DATETIME, "TS_DATETIME"},
{ERROR_SYS_INTERNAL, "SYS_INTERNAL"},
{ERROR_QUE_CURRENT_NAME, "QUE_CURRENT_NAME"},
{ERROR_QUE_PROC_NOT_OWNED, "QUE_PROC_NOT_OWNED"},
{ERROR_QUE_PROC_OWNED, "QUE_PROC_OWNED"},
{ERROR_QUE_DUPLICATE, "QUE_DUPLICATE"},
{ERROR_QUE_ELEMENT_NOT_EXIST, "QUE_ELEMENT_NOT_EXIST"},
{ERROR_QUE_NO_MEMORY, "QUE_NO_MEMORY"},
{ERROR_QUE_INVALID_NAME, "QUE_INVALID_NAME"},
{ERROR_QUE_INVALID_PRIORITY, "QUE_INVALID_PRIORITY"},
{ERROR_QUE_INVALID_HANDLE, "QUE_INVALID_HANDLE"},
{ERROR_QUE_LINK_NOT_FOUND, "QUE_LINK_NOT_FOUND"},
{ERROR_QUE_MEMORY_ERROR, "QUE_MEMORY_ERROR"},
{ERROR_QUE_PREV_AT_END, "QUE_PREV_AT_END"},
{ERROR_QUE_PROC_NO_ACCESS, "QUE_PROC_NO_ACCESS"},
{ERROR_QUE_EMPTY, "QUE_EMPTY"},
{ERROR_QUE_NAME_NOT_EXIST, "QUE_NAME_NOT_EXIST"},
{ERROR_QUE_NOT_INITIALIZED, "QUE_NOT_INITIALIZED"},
{ERROR_QUE_UNABLE_TO_ACCESS, "QUE_UNABLE_TO_ACCESS"},
{ERROR_QUE_UNABLE_TO_ADD, "QUE_UNABLE_TO_ADD"},
{ERROR_QUE_UNABLE_TO_INIT, "QUE_UNABLE_TO_INIT"},
{ERROR_VIO_INVALID_MASK, "VIO_INVALID_MASK"},
{ERROR_VIO_PTR, "VIO_PTR"},
{ERROR_VIO_APTR, "VIO_APTR"},
{ERROR_VIO_RPTR, "VIO_RPTR"},
{ERROR_VIO_CPTR, "VIO_CPTR"},
{ERROR_VIO_LPTR, "VIO_LPTR"},
{ERROR_VIO_MODE, "VIO_MODE"},
{ERROR_VIO_WIDTH, "VIO_WIDTH"},
{ERROR_VIO_ATTR, "VIO_ATTR"},
{ERROR_VIO_ROW, "VIO_ROW"},
{ERROR_VIO_COL, "VIO_COL"},
{ERROR_VIO_TOPROW, "VIO_TOPROW"},
{ERROR_VIO_BOTROW, "VIO_BOTROW"},
{ERROR_VIO_RIGHTCOL, "VIO_RIGHTCOL"},
{ERROR_VIO_LEFTCOL, "VIO_LEFTCOL"},
{ERROR_SCS_CALL, "SCS_CALL"},
{ERROR_SCS_VALUE, "SCS_VALUE"},
{ERROR_VIO_WAIT_FLAG, "VIO_WAIT_FLAG"},
{ERROR_VIO_UNLOCK, "VIO_UNLOCK"},
{ERROR_SGS_NOT_SESSION_MGR, "SGS_NOT_SESSION_MGR"},
{ERROR_SMG_INVALID_SGID, "SMG_INVALID_SGID"},
{ERROR_SMG_INVALID_SESSION_ID, "SMG_INVALID_SESSION_ID"},
{ERROR_SMG_NOSG, "SMG_NOSG"},
{ERROR_SMG_NO_SESSIONS, "SMG_NO_SESSIONS"},
{ERROR_SMG_GRP_NOT_FOUND, "SMG_GRP_NOT_FOUND"},
{ERROR_SMG_SESSION_NOT_FOUND, "SMG_SESSION_NOT_FOUND"},
{371, "SMG SESSION NOT FOUND"},
{ERROR_SMG_SET_TITLE, "SMG_SET_TITLE"},
{ERROR_KBD_PARAMETER, "KBD_PARAMETER"},
{ERROR_KBD_NO_DEVICE, "KBD_NO_DEVICE"},
{ERROR_KBD_INVALID_IOWAIT, "KBD_INVALID_IOWAIT"},
{ERROR_KBD_INVALID_LENGTH, "KBD_INVALID_LENGTH"},
{ERROR_KBD_INVALID_ECHO_MASK, "KBD_INVALID_ECHO_MASK"},
{ERROR_KBD_INVALID_INPUT_MASK, "KBD_INVALID_INPUT_MASK"},
{ERROR_MON_INVALID_PARMS, "MON_INVALID_PARMS"},
{ERROR_MON_INVALID_DEVNAME, "MON_INVALID_DEVNAME"},
{ERROR_MON_INVALID_HANDLE, "MON_INVALID_HANDLE"},
{ERROR_MON_BUFFER_TOO_SMALL, "MON_BUFFER_TOO_SMALL"},
{ERROR_MON_BUFFER_EMPTY, "MON_BUFFER_EMPTY"},
{ERROR_MON_DATA_TOO_LARGE, "MON_DATA_TOO_LARGE"},
{ERROR_MOUSE_NO_DEVICE, "MOUSE_NO_DEVICE"},
{ERROR_MOUSE_INV_HANDLE, "MOUSE_INV_HANDLE"},
{ERROR_MOUSE_INV_PARMS, "MOUSE_INV_PARMS"},
{ERROR_MOUSE_CANT_RESET, "MOUSE_CANT_RESET"},
{ERROR_MOUSE_DISPLAY_PARMS, "MOUSE_DISPLAY_PARMS"},
{ERROR_MOUSE_INV_MODULE, "MOUSE_INV_MODULE"},
{ERROR_MOUSE_INV_ENTRY_PT, "MOUSE_INV_ENTRY_PT"},
{ERROR_MOUSE_INV_MASK, "MOUSE_INV_MASK"},
{NO_ERROR_MOUSE_NO_DATA, "NO_ERROR_MOUSE_NO_DATA"},
{NO_ERROR_MOUSE_PTR_DRAWN, "NO_ERROR_MOUSE_PTR_DRAWN"},
{ERROR_INVALID_FREQUENCY, "INVALID_FREQUENCY"},
{ERROR_NLS_NO_COUNTRY_FILE, "NLS_NO_COUNTRY_FILE"},
{ERROR_NLS_OPEN_FAILED, "NLS_OPEN_FAILED"},
{ERROR_NLS_NO_CTRY_CODE, "NLS_NO_CTRY_CODE"},
{ERROR_NO_COUNTRY_OR_CODEPAGE, "NO_COUNTRY_OR_CODEPAGE"},
{ERROR_NLS_TABLE_TRUNCATED, "NLS_TABLE_TRUNCATED"},
{ERROR_NLS_BAD_TYPE, "NLS_BAD_TYPE"},
{ERROR_NLS_TYPE_NOT_FOUND, "NLS_TYPE_NOT_FOUND"},
{ERROR_VIO_SMG_ONLY, "VIO_SMG_ONLY"},
{ERROR_VIO_INVALID_ASCIIZ, "VIO_INVALID_ASCIIZ"},
{ERROR_VIO_DEREGISTER, "VIO_DEREGISTER"},
{ERROR_VIO_NO_POPUP, "VIO_NO_POPUP"},
{ERROR_VIO_EXISTING_POPUP, "VIO_EXISTING_POPUP"},
{ERROR_KBD_SMG_ONLY, "KBD_SMG_ONLY"},
{ERROR_KBD_INVALID_ASCIIZ, "KBD_INVALID_ASCIIZ"},
{ERROR_KBD_INVALID_MASK, "KBD_INVALID_MASK"},
{ERROR_KBD_REGISTER, "KBD_REGISTER"},
{ERROR_KBD_DEREGISTER, "KBD_DEREGISTER"},
{ERROR_MOUSE_SMG_ONLY, "MOUSE_SMG_ONLY"},
{ERROR_MOUSE_INVALID_ASCIIZ, "MOUSE_INVALID_ASCIIZ"},
{ERROR_MOUSE_INVALID_MASK, "MOUSE_INVALID_MASK"},
{ERROR_MOUSE_REGISTER, "MOUSE_REGISTER"},
{ERROR_MOUSE_DEREGISTER, "MOUSE_DEREGISTER"},
{ERROR_SMG_BAD_ACTION, "SMG_BAD_ACTION"},
{ERROR_SMG_INVALID_CALL, "SMG_INVALID_CALL"},
{ERROR_SCS_SG_NOTFOUND, "SCS_SG_NOTFOUND"},
{ERROR_SCS_NOT_SHELL, "SCS_NOT_SHELL"},
{ERROR_VIO_INVALID_PARMS, "VIO_INVALID_PARMS"},
{ERROR_VIO_FUNCTION_OWNED, "VIO_FUNCTION_OWNED"},
{ERROR_VIO_RETURN, "VIO_RETURN"},
{ERROR_SCS_INVALID_FUNCTION, "SCS_INVALID_FUNCTION"},
{ERROR_SCS_NOT_SESSION_MGR, "SCS_NOT_SESSION_MGR"},
{ERROR_VIO_REGISTER, "VIO_REGISTER"},
{ERROR_VIO_NO_MODE_THREAD, "VIO_NO_MODE_THREAD"},
{ERROR_VIO_NO_SAVE_RESTORE_THD, "VIO_NO_SAVE_RESTORE_THD"},
{ERROR_VIO_IN_BG, "VIO_IN_BG"},
{ERROR_VIO_ILLEGAL_DURING_POPUP, "VIO_ILLEGAL_DURING_POPUP"},
{ERROR_SMG_NOT_BASESHELL, "SMG_NOT_BASESHELL"},
{ERROR_SMG_BAD_STATUSREQ, "SMG_BAD_STATUSREQ"},
{ERROR_QUE_INVALID_WAIT, "QUE_INVALID_WAIT"},
{ERROR_VIO_LOCK, "VIO_LOCK"},
{ERROR_MOUSE_INVALID_IOWAIT, "MOUSE_INVALID_IOWAIT"},
{ERROR_VIO_INVALID_HANDLE, "VIO_INVALID_HANDLE"},
{ERROR_VIO_ILLEGAL_DURING_LOCK, "VIO_ILLEGAL_DURING_LOCK"},
{ERROR_VIO_INVALID_LENGTH, "VIO_INVALID_LENGTH"},
{ERROR_KBD_INVALID_HANDLE, "KBD_INVALID_HANDLE"},
{ERROR_KBD_NO_MORE_HANDLE, "KBD_NO_MORE_HANDLE"},
{ERROR_KBD_CANNOT_CREATE_KCB, "KBD_CANNOT_CREATE_KCB"},
{ERROR_KBD_CODEPAGE_LOAD_INCOMPL, "KBD_CODEPAGE_LOAD_INCOMPL"},
{ERROR_KBD_INVALID_CODEPAGE_ID, "KBD_INVALID_CODEPAGE_ID"},
{ERROR_KBD_NO_CODEPAGE_SUPPORT, "KBD_NO_CODEPAGE_SUPPORT"},
{ERROR_KBD_FOCUS_REQUIRED, "KBD_FOCUS_REQUIRED"},
{ERROR_KBD_FOCUS_ALREADY_ACTIVE, "KBD_FOCUS_ALREADY_ACTIVE"},
{ERROR_KBD_KEYBOARD_BUSY, "KBD_KEYBOARD_BUSY"},
{ERROR_KBD_INVALID_CODEPAGE, "KBD_INVALID_CODEPAGE"},
{ERROR_KBD_UNABLE_TO_FOCUS, "KBD_UNABLE_TO_FOCUS"},
{ERROR_SMG_SESSION_NON_SELECT, "SMG_SESSION_NON_SELECT"},
{ERROR_SMG_SESSION_NOT_FOREGRND, "SMG_SESSION_NOT_FOREGRND"},
{ERROR_SMG_SESSION_NOT_PARENT, "SMG_SESSION_NOT_PARENT"},
{ERROR_SMG_INVALID_START_MODE, "SMG_INVALID_START_MODE"},
{ERROR_SMG_INVALID_RELATED_OPT, "SMG_INVALID_RELATED_OPT"},
{ERROR_SMG_INVALID_BOND_OPTION, "SMG_INVALID_BOND_OPTION"},
{ERROR_SMG_INVALID_SELECT_OPT, "SMG_INVALID_SELECT_OPT"},
{ERROR_SMG_START_IN_BACKGROUND, "SMG_START_IN_BACKGROUND"},
{ERROR_SMG_INVALID_STOP_OPTION, "SMG_INVALID_STOP_OPTION"},
{ERROR_SMG_BAD_RESERVE, "SMG_BAD_RESERVE"},
{ERROR_SMG_PROCESS_NOT_PARENT, "SMG_PROCESS_NOT_PARENT"},
{ERROR_SMG_INVALID_DATA_LENGTH, "SMG_INVALID_DATA_LENGTH"},
{ERROR_SMG_NOT_BOUND, "SMG_NOT_BOUND"},
{ERROR_SMG_RETRY_SUB_ALLOC, "SMG_RETRY_SUB_ALLOC"},
{ERROR_KBD_DETACHED, "KBD_DETACHED"},
{ERROR_VIO_DETACHED, "VIO_DETACHED"},
{ERROR_MOU_DETACHED, "MOU_DETACHED"},
{ERROR_VIO_FONT, "VIO_FONT"},
{ERROR_VIO_USER_FONT, "VIO_USER_FONT"},
{ERROR_VIO_BAD_CP, "VIO_BAD_CP"},
{ERROR_VIO_NO_CP, "VIO_NO_CP"},
{ERROR_VIO_NA_CP, "VIO_NA_CP"},
{ERROR_INVALID_CODE_PAGE, "INVALID_CODE_PAGE"},
{ERROR_CPLIST_TOO_SMALL, "CPLIST_TOO_SMALL"},
{ERROR_CP_NOT_MOVED, "CP_NOT_MOVED"},
{ERROR_MODE_SWITCH_INIT, "MODE_SWITCH_INIT"},
{ERROR_CODE_PAGE_NOT_FOUND, "CODE_PAGE_NOT_FOUND"},
{ERROR_UNEXPECTED_SLOT_RETURNED, "UNEXPECTED_SLOT_RETURNED"},
{ERROR_SMG_INVALID_TRACE_OPTION, "SMG_INVALID_TRACE_OPTION"},
{ERROR_VIO_INTERNAL_RESOURCE, "VIO_INTERNAL_RESOURCE"},
{ERROR_VIO_SHELL_INIT, "VIO_SHELL_INIT"},
{ERROR_SMG_NO_HARD_ERRORS, "SMG_NO_HARD_ERRORS"},
{ERROR_CP_SWITCH_INCOMPLETE, "CP_SWITCH_INCOMPLETE"},
{ERROR_VIO_TRANSPARENT_POPUP, "VIO_TRANSPARENT_POPUP"},
{ERROR_CRITSEC_OVERFLOW, "CRITSEC_OVERFLOW"},
{ERROR_CRITSEC_UNDERFLOW, "CRITSEC_UNDERFLOW"},
{ERROR_VIO_BAD_RESERVE, "VIO_BAD_RESERVE"},
{ERROR_INVALID_ADDRESS, "INVALID_ADDRESS"},
{ERROR_ZERO_SELECTORS_REQUESTED, "ZERO_SELECTORS_REQUESTED"},
{ERROR_NOT_ENOUGH_SELECTORS_AVA, "NOT_ENOUGH_SELECTORS_AVA"},
{ERROR_INVALID_SELECTOR, "INVALID_SELECTOR"},
{ERROR_SMG_INVALID_PROGRAM_TYPE, "SMG_INVALID_PROGRAM_TYPE"},
{ERROR_SMG_INVALID_PGM_CONTROL, "SMG_INVALID_PGM_CONTROL"},
{ERROR_SMG_INVALID_INHERIT_OPT, "SMG_INVALID_INHERIT_OPT"},
{ERROR_VIO_EXTENDED_SG, "VIO_EXTENDED_SG"},
{ERROR_VIO_NOT_PRES_MGR_SG, "VIO_NOT_PRES_MGR_SG"},
{ERROR_VIO_SHIELD_OWNED, "VIO_SHIELD_OWNED"},
{ERROR_VIO_NO_MORE_HANDLES, "VIO_NO_MORE_HANDLES"},
{ERROR_VIO_SEE_ERROR_LOG, "VIO_SEE_ERROR_LOG"},
{ERROR_VIO_ASSOCIATED_DC, "VIO_ASSOCIATED_DC"},
{ERROR_KBD_NO_CONSOLE, "KBD_NO_CONSOLE"},
{ERROR_MOUSE_NO_CONSOLE, "MOUSE_NO_CONSOLE"},
{ERROR_MOUSE_INVALID_HANDLE, "MOUSE_INVALID_HANDLE"},
{ERROR_SMG_INVALID_DEBUG_PARMS, "SMG_INVALID_DEBUG_PARMS"},
{ERROR_KBD_EXTENDED_SG, "KBD_EXTENDED_SG"},
{ERROR_MOU_EXTENDED_SG, "MOU_EXTENDED_SG"},
{ERROR_SMG_INVALID_ICON_FILE, "SMG_INVALID_ICON_FILE"},
{ERROR_TRC_PID_NON_EXISTENT, "TRC_PID_NON_EXISTENT"},
{ERROR_TRC_COUNT_ACTIVE, "TRC_COUNT_ACTIVE"},
{ERROR_TRC_SUSPENDED_BY_COUNT, "TRC_SUSPENDED_BY_COUNT"},
{ERROR_TRC_COUNT_INACTIVE, "TRC_COUNT_INACTIVE"},
{ERROR_TRC_COUNT_REACHED, "TRC_COUNT_REACHED"},
{ERROR_NO_MC_TRACE, "NO_MC_TRACE"},
{ERROR_MC_TRACE, "MC_TRACE"},
{ERROR_TRC_COUNT_ZERO, "TRC_COUNT_ZERO"},
{ERROR_SMG_TOO_MANY_DDS, "SMG_TOO_MANY_DDS"},
{ERROR_SMG_INVALID_NOTIFICATION, "SMG_INVALID_NOTIFICATION"},
{ERROR_LF_INVALID_FUNCTION, "LF_INVALID_FUNCTION"},
{ERROR_LF_NOT_AVAIL, "LF_NOT_AVAIL"},
{ERROR_LF_SUSPENDED, "LF_SUSPENDED"},
{ERROR_LF_BUF_TOO_SMALL, "LF_BUF_TOO_SMALL"},
{ERROR_LF_BUFFER_CORRUPTED, "LF_BUFFER_CORRUPTED"},
{ERROR_LF_BUFFER_FULL, "LF_BUFFER_FULL"},
{ERROR_LF_INVALID_DAEMON, "LF_INVALID_DAEMON"},
{ERROR_LF_INVALID_RECORD, "LF_INVALID_RECORD"},
{ERROR_LF_INVALID_TEMPL, "LF_INVALID_TEMPL"},
{ERROR_LF_INVALID_SERVICE, "LF_INVALID_SERVICE"},
{ERROR_LF_GENERAL_FAILURE, "LF_GENERAL_FAILURE"},
{ERROR_LF_INVALID_ID, "LF_INVALID_ID"},
{ERROR_LF_INVALID_HANDLE, "LF_INVALID_HANDLE"},
{ERROR_LF_NO_ID_AVAIL, "LF_NO_ID_AVAIL"},
{ERROR_LF_TEMPLATE_AREA_FULL, "LF_TEMPLATE_AREA_FULL"},
{ERROR_LF_ID_IN_USE, "LF_ID_IN_USE"},
{ERROR_MOU_NOT_INITIALIZED, "MOU_NOT_INITIALIZED"},
{ERROR_MOUINITREAL_DONE, "MOUINITREAL_DONE"},
{ERROR_DOSSUB_CORRUPTED, "DOSSUB_CORRUPTED"},
{ERROR_MOUSE_CALLER_NOT_SUBSYS, "MOUSE_CALLER_NOT_SUBSYS"},
{ERROR_ARITHMETIC_OVERFLOW, "ARITHMETIC_OVERFLOW"},
{ERROR_TMR_NO_DEVICE, "TMR_NO_DEVICE"},
{ERROR_TMR_INVALID_TIME, "TMR_INVALID_TIME"},
{ERROR_PVW_INVALID_ENTITY, "PVW_INVALID_ENTITY"},
{ERROR_PVW_INVALID_ENTITY_TYPE, "PVW_INVALID_ENTITY_TYPE"},
{ERROR_PVW_INVALID_SPEC, "PVW_INVALID_SPEC"},
{ERROR_PVW_INVALID_RANGE_TYPE, "PVW_INVALID_RANGE_TYPE"},
{ERROR_PVW_INVALID_COUNTER_BLK, "PVW_INVALID_COUNTER_BLK"},
{ERROR_PVW_INVALID_TEXT_BLK, "PVW_INVALID_TEXT_BLK"},
{ERROR_PRF_NOT_INITIALIZED, "PRF_NOT_INITIALIZED"},
{ERROR_PRF_ALREADY_INITIALIZED, "PRF_ALREADY_INITIALIZED"},
{ERROR_PRF_NOT_STARTED, "PRF_NOT_STARTED"},
{ERROR_PRF_ALREADY_STARTED, "PRF_ALREADY_STARTED"},
{ERROR_PRF_TIMER_OUT_OF_RANGE, "PRF_TIMER_OUT_OF_RANGE"},
{ERROR_PRF_TIMER_RESET, "PRF_TIMER_RESET"},
{549, "HPFS_CHKDSK_NO_PARM_SPACE"},
{550, "HPFS_CHKDSK_NORECOGNIZE"},
{551, "HPFS_CHKDSK_NOROOT_FIND"},
{552, "HPFS_CHKDSK_NOFIX_FS_ERROR"},
{553, "HPFS_CHKDSK_CORRECT_FS_ERR"},
{554, "HPFS_CHKDSK_ORGAN_FIX"},
{555, "HPFS_CHKDSK_RELOC_BBPDATA"},
{556, "HPFS_CHKDSK_REM_CORRU_BLOC"},
{557, "HPFS_CHKDSK_REM_CORRUP_FIL"},
{558, "HPFS_CHKDSK_FIX_SPACE_ALLO"},
{559, "HPFS_NOT_FORMATTED_DISK"},
{560, "HPFS_CHKDSK_COR_ALLOC"},
{561, "HPFS_CHKDSK_SEARC_UNALLOC"},
{562, "HPFS_CHKDSK_DET_LOST_DATA"},
{563, "HPFS_CHKDSK_PERCENT_SEARC"},
{564, "HPFS_CHKDSK_LOST_DATASEARC"},
{565, "HPFS_CHKDSK_CRIT_NOREAD"},
{566, "HPFS_CHKDSK_DISK_INUSE"},
{567, "HPFS_CHKDSK_RECOVTEMP_RELOC"},
{568, "HPFS_TOTAL_DISK_SPACE"},
{569, "HPFS_DIR_KBYTES"},
{570, "HPFS_FILE_KBYTES"},
{571, "HPFS_KBYTES_AVAILABLE"},
{572, "HPFS_CHKDSK_PLACE_REC_FILE"},
{573, "HPFS_CHKDSK_RECO_DIR_AS"},
{574, "HPFS_CHKDSK_PLACEED_DATA"},
{575, "HPFS_CHKDSK_RECOV_EA"},
{576, "HPFS_CHKDSK_FIND_EA_INTEM"},
{577, "HPFS_CHKDSK_RELOC_TEMP_EA"},
{578, "HPFS_CHKDSK_RELOC_AC_LIST"},
{579, "HPFS_CHKDSK_LIST_NORELOC"},
{580, "HPFS_CHKDSK_TRUN_EA_LIST"},
{581, "HPFS_CHKDSK_TRUN_EA_NAME"},
{582, "HPFS_CHKDSK_TRUN_EA_BBLOCK"},
{583, "HPFS_CHKDSK_REM_INVALID_EA"},
{584, "HPFS_CHKDSK_FIX_EA_ALLOC"},
{585, "HPFS_CHKDSK_FIX_ALACCCTRL"},
{586, "HPFS_CHKDSK_ACCTR_LIST_BBL"},
{587, "HPFS_CHKDSK_REM_ACLIST"},
{588, "HPFS_CHKDSK_FOUND_DATANORL"},
{589, "HPFS_WRONG_VERSION"},
{590, "HPFS_CHKDSK_FOUND_DATATEMP"},
{591, "HPFS_CHKDSK_FIX_TEMPSTATUS"},
{592, "HPFS_CHKDSK_FIX_NEEDEADATA"},
{593, "HPFS_RECOVER_PARM_ERROR"},
{594, "HPFS_RECOV_FILE_NOT_FOUND"},
{595, "HPFS_RECOV_UNKNOWN_ERROR"},
{596, "HPFS_RECOV_NOT_ENOUGH_MEM"},
{597, "HPFS_RECOV_NOWRITE_DATA"},
{598, "HPFS_RECOV_NOTEMP_CREATE"},
{599, "HPFS_RECOV_EA_NOREAD"},
{600, "HPFS_RECOV_FILE_BYTES"},
{601, "HPFS_RECOV_BAD_BYTES_RECOV"},
{602, "HPFS_RECOV_FILEBYTES_NOREC"},
{603, "HPFS_RECOV_DISK_INUSE"},
{604, "HPFS_RECOV_FILE_NODELETE"},
{605, "HPFS_RECOV_NOCREATE_NEWFILE"},
{606, "HPFS_RECOV_SYSTEM_ERROR"},
{607, "HPFS_SYS_PARM_ERROR"},
{608, "HPFS_SYS_CANNOT_INSTALL"},
{609, "HPFS_SYS_DRIVE_NOTFORMATED"},
{610, "HPFS_SYS_FILE_NOCREATE"},
{611, "HPFS_SIZE_EXCEED"},
{612, "HPFS_SYNTAX_ERR"},
{613, "HPFS_NOTENOUGH_MEM"},
{614, "HPFS_WANT_MEM"},
{615, "HPFS_GET_RETURNED"},
{616, "HPFS_SET_RETURNED"},
{617, "HPFS_BOTH_RETURNED"},
{618, "HPFS_STOP_RETURNED"},
{619, "HPFS_SETPRTYRETURNED"},
{620, "HPFS_ALCSG_RETURNED"},
{621, "HPFS_MSEC_SET"},
{622, "HPFS_OPTIONS"},
{623, "HPFS_POS_NUM_VALUE"},
{624, "HPFS_VALUE_TOO_LARGE"},
{625, "HPFS_LAZY_NOT_VALID"},
{626, "HPFS_VOLUME_ERROR"},
{627, "HPFS_VOLUME_DIRTY"},
{628, "HPFS_NEW_SECTOR"},
{629, "HPFS_FORMAT_PARM_ERROR"},
{630, "HPFS_CANNOT_ACCESS_CONFIG"},
{631, "HPFS_RECOV_FILE"},
{632, "HPFS_CHKDSK_KBYTES_RESERVE"},
{633, "HPFS_CHKDSK_KBYTES_IN_EA"},
{634, "HPFS_BYTEBUF_SET"},
{635, "HPFS_FORMATTING_COMPLETE"},
{636, "HPFS_WRONG_VOLUME_LABEL"},
{637, "HPFS_FMAT_TOO_MANY_DRS"},
{638, "VDD_UNSUPPORTED_ACCESS"},
{ERROR_VDD_LOCK_USEAGE_DENIED, "VDD_LOCK_USEAGE_DENIED"},
{ERROR_TIMEOUT, "TIMEOUT"},
{ERROR_VDM_DOWN, "VDM_DOWN"},
{ERROR_VDM_LIMIT, "VDM_LIMIT"},
{ERROR_VDD_NOT_FOUND, "VDD_NOT_FOUND"},
{ERROR_INVALID_CALLER, "INVALID_CALLER"},
{ERROR_PID_MISMATCH, "PID_MISMATCH"},
{ERROR_INVALID_VDD_HANDLE, "INVALID_VDD_HANDLE"},
{ERROR_VLPT_NO_SPOOLER, "VLPT_NO_SPOOLER"},
{ERROR_VCOM_DEVICE_BUSY, "VCOM_DEVICE_BUSY"},
{ERROR_VLPT_DEVICE_BUSY, "VLPT_DEVICE_BUSY"},
{ERROR_NESTING_TOO_DEEP, "NESTING_TOO_DEEP"},
{ERROR_VDD_MISSING, "VDD_MISSING"},
{ERROR_BIDI_INVALID_LENGTH, "BIDI_INVALID_LENGTH"},
{ERROR_BIDI_INVALID_INCREMENT, "BIDI_INVALID_INCREMENT"},
{ERROR_BIDI_INVALID_COMBINATION, "BIDI_INVALID_COMBINATION"},
{ERROR_BIDI_INVALID_RESERVED, "BIDI_INVALID_RESERVED"},
{ERROR_BIDI_INVALID_EFFECT, "BIDI_INVALID_EFFECT"},
{ERROR_BIDI_INVALID_CSDREC, "BIDI_INVALID_CSDREC"},
{ERROR_BIDI_INVALID_CSDSTATE, "BIDI_INVALID_CSDSTATE"},
{ERROR_BIDI_INVALID_LEVEL, "BIDI_INVALID_LEVEL"},
{ERROR_BIDI_INVALID_TYPE_SUPPORT, "BIDI_INVALID_TYPE_SUPPORT"},
{ERROR_BIDI_INVALID_ORIENTATION, "BIDI_INVALID_ORIENTATION"},
{ERROR_BIDI_INVALID_NUM_SHAPE, "BIDI_INVALID_NUM_SHAPE"},
{ERROR_BIDI_INVALID_CSD, "BIDI_INVALID_CSD"},
{ERROR_BIDI_NO_SUPPORT, "BIDI_NO_SUPPORT"},
{NO_ERROR_BIDI_RW_INCOMPLETE, "NO_ERROR_BIDI_RW_INCOMPLETE"},
{689, "HPFS LAZY ON"},
{690, "HPFS LAZY OFF"},
{ERROR_IMP_INVALID_PARM, "IMP_INVALID_PARM"},
{ERROR_IMP_INVALID_LENGTH, "IMP_INVALID_LENGTH"},
{MSG_HPFS_DISK_ERROR_WARN, "MSG_HPFS_DISK_ERROR_WARN"},
{ERROR_MON_BAD_BUFFER, "MON_BAD_BUFFER"},
{ERROR_MODULE_CORRUPTED, "MODULE_CORRUPTED"},
{ERROR_SM_OUTOF_SWAPFILE, "SM_OUTOF_SWAPFILE"},
{ERROR_LF_TIMEOUT, "LF_TIMEOUT"},
{ERROR_LF_SUSPEND_SUCCESS, "LF_SUSPEND_SUCCESS"},
{ERROR_LF_RESUME_SUCCESS, "LF_RESUME_SUCCESS"},
{ERROR_LF_REDIRECT_SUCCESS, "LF_REDIRECT_SUCCESS"},
{ERROR_LF_REDIRECT_FAILURE, "LF_REDIRECT_FAILURE"},
{ERROR_SWAPPER_NOT_ACTIVE, "SWAPPER_NOT_ACTIVE"},
{ERROR_INVALID_SWAPID, "INVALID_SWAPID"},
{ERROR_IOERR_SWAP_FILE, "IOERR_SWAP_FILE"},
{ERROR_SWAP_TABLE_FULL, "SWAP_TABLE_FULL"},
{ERROR_SWAP_FILE_FULL, "SWAP_FILE_FULL"},
{ERROR_CANT_INIT_SWAPPER, "CANT_INIT_SWAPPER"},
{ERROR_SWAPPER_ALREADY_INIT, "SWAPPER_ALREADY_INIT"},
{ERROR_PMM_INSUFFICIENT_MEMORY, "PMM_INSUFFICIENT_MEMORY"},
{ERROR_PMM_INVALID_FLAGS, "PMM_INVALID_FLAGS"},
{ERROR_PMM_INVALID_ADDRESS, "PMM_INVALID_ADDRESS"},
{ERROR_PMM_LOCK_FAILED, "PMM_LOCK_FAILED"},
{ERROR_PMM_UNLOCK_FAILED, "PMM_UNLOCK_FAILED"},
{ERROR_PMM_MOVE_INCOMPLETE, "PMM_MOVE_INCOMPLETE"},
{ERROR_UCOM_DRIVE_RENAMED, "UCOM_DRIVE_RENAMED"},
{ERROR_UCOM_FILENAME_TRUNCATED, "UCOM_FILENAME_TRUNCATED"},
{ERROR_UCOM_BUFFER_LENGTH, "UCOM_BUFFER_LENGTH"},
{ERROR_MON_CHAIN_HANDLE, "MON_CHAIN_HANDLE"},
{ERROR_MON_NOT_REGISTERED, "MON_NOT_REGISTERED"},
{ERROR_SMG_ALREADY_TOP, "SMG_ALREADY_TOP"},
{ERROR_PMM_ARENA_MODIFIED, "PMM_ARENA_MODIFIED"},
{ERROR_SMG_PRINTER_OPEN, "SMG_PRINTER_OPEN"},
{ERROR_PMM_SET_FLAGS_FAILED, "PMM_SET_FLAGS_FAILED"},
{ERROR_INVALID_DOS_DD, "INVALID_DOS_DD"},
{ERROR_BLOCKED, "BLOCKED"},
{ERROR_NOBLOCK, "NOBLOCK"},
{ERROR_INSTANCE_SHARED, "INSTANCE_SHARED"},
{ERROR_NO_OBJECT, "NO_OBJECT"},
{ERROR_PARTIAL_ATTACH, "PARTIAL_ATTACH"},
{ERROR_INCACHE, "INCACHE"},
{ERROR_SWAP_IO_PROBLEMS, "SWAP_IO_PROBLEMS"},
{ERROR_CROSSES_OBJECT_BOUNDARY, "CROSSES_OBJECT_BOUNDARY"},
{ERROR_LONGLOCK, "LONGLOCK"},
{ERROR_SHORTLOCK, "SHORTLOCK"},
{ERROR_UVIRTLOCK, "UVIRTLOCK"},
{ERROR_ALIASLOCK, "ALIASLOCK"},
{ERROR_ALIAS, "ALIAS"},
{ERROR_NO_MORE_HANDLES, "NO_MORE_HANDLES"},
{ERROR_SCAN_TERMINATED, "SCAN_TERMINATED"},
{ERROR_TERMINATOR_NOT_FOUND, "TERMINATOR_NOT_FOUND"},
{ERROR_NOT_DIRECT_CHILD, "NOT_DIRECT_CHILD"},
{ERROR_DELAY_FREE, "DELAY_FREE"},
{ERROR_GUARDPAGE, "GUARDPAGE"},
{ERROR_SWAPERROR, "SWAPERROR"},
{ERROR_LDRERROR, "LDRERROR"},
{ERROR_NOMEMORY, "NOMEMORY"},
{ERROR_NOACCESS, "NOACCESS"},
{ERROR_NO_DLL_TERM, "NO_DLL_TERM"},
{ERROR_CPSIO_CODE_PAGE_INVALID, "CPSIO_CODE_PAGE_INVALID"},
{ERROR_CPSIO_NO_SPOOLER, "CPSIO_NO_SPOOLER"},
{ERROR_CPSIO_FONT_ID_INVALID, "CPSIO_FONT_ID_INVALID"},
{ERROR_CPSIO_INTERNAL_ERROR, "CPSIO_INTERNAL_ERROR"},
{ERROR_CPSIO_INVALID_PTR_NAME, "CPSIO_INVALID_PTR_NAME"},
{ERROR_CPSIO_NOT_ACTIVE, "CPSIO_NOT_ACTIVE"},
{ERROR_CPSIO_PID_FULL, "CPSIO_PID_FULL"},
{ERROR_CPSIO_PID_NOT_FOUND, "CPSIO_PID_NOT_FOUND"},
{ERROR_CPSIO_READ_CTL_SEQ, "CPSIO_READ_CTL_SEQ"},
{ERROR_CPSIO_READ_FNT_DEF, "CPSIO_READ_FNT_DEF"},
{ERROR_CPSIO_WRITE_ERROR, "CPSIO_WRITE_ERROR"},
{ERROR_CPSIO_WRITE_FULL_ERROR, "CPSIO_WRITE_FULL_ERROR"},
{ERROR_CPSIO_WRITE_HANDLE_BAD, "CPSIO_WRITE_HANDLE_BAD"},
{ERROR_CPSIO_SWIT_LOAD, "CPSIO_SWIT_LOAD"},
{ERROR_CPSIO_INV_COMMAND, "CPSIO_INV_COMMAND"},
{ERROR_CPSIO_NO_FONT_SWIT, "CPSIO_NO_FONT_SWIT"},
{ERROR_ENTRY_IS_CALLGATE, "ENTRY_IS_CALLGATE"},
{0, NULL}
   };


   if (error != 0) {
      int done = 0;
      int i = 0;
      while (!done && err[i].error_ != 0 && err[i].errorStr_ != NULL) {
         if (error != err[i].error_)
            ++i;
         else
            done = 1;
      }
      cout << endl << "Error: (" << error << ") ";
      if (done) {
         cout << err[i].errorStr_;
      } else {
         cout << "Unknown error";
      }
      cout << endl;
      if (msg != NULL)
         cout << msg;
   }
}

